// test_CheckBox.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "CheckBox.h"


bool bWinNT = false;
HICON g_hIcon;

//------------------------------------
// Forward declarations
//
void ToggleKey (int key);						 // toggle Num, Caps, Scroll lock
BOOL CALLBACK DlgProc (HWND,UINT,WPARAM,LPARAM); // dialog procedure


//------------------------------------
CCheckBox	num_1 (IDB_LED_STATES,11),		// ***** step 1 ***** //
			cap_1 (IDB_LED_STATES,11),
			scr_1 (IDB_LED_STATES,11);

CCheckBox	num_2 (IDB_BOX_STATES,13),
			cap_2 (IDB_BOX_STATES,13),
			scr_2 (IDB_BOX_STATES,13);

CCheckBox	cb_enable (IDB_BOX_1,13);
//------------------------------------


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

	CCheckBox::m_hInst = hInstance;			// ***** step 2 ***** //

	OSVERSIONINFO os;
	os.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx (&os);
	if (os.dwPlatformId == VER_PLATFORM_WIN32_NT)
		bWinNT = true;

	g_hIcon = ::LoadIcon (hInstance, MAKEINTRESOURCE(IDI_ICON));
		
 	// display main dialog
	::DialogBox (hInstance, MAKEINTRESOURCE (IDD_DIALOG), NULL, DlgProc);

	return 0;
}


//------------------------------------
// DlgProc
// dialog box procedure
//------------------------------------
BOOL CALLBACK DlgProc (HWND hDlg,      // handle to dialog box
					   UINT uMsg,      // message
					   WPARAM wParam,  // first message parameter
					   LPARAM lParam ) // second message parameter
{
	switch (uMsg) {

	case WM_INITDIALOG:

		SendMessage (hDlg, WM_SETICON,ICON_BIG,  (LPARAM)g_hIcon);	// Set big icon
		SendMessage (hDlg, WM_SETICON,ICON_SMALL,(LPARAM)g_hIcon);	// Set small icon
			
		
		PostMessage (hDlg,WM_KEYDOWN,VK_TAB,0);

		//--------------------------------------
		// subclass controls
		//
		num_1. Subclass (IDC_NUM_1, hDlg);	// ***** step 3 ***** //
		cap_1. Subclass (IDC_CAP_1, hDlg);
		scr_1. Subclass (IDC_SCR_1, hDlg);

		num_2. Subclass (IDC_NUM_2, hDlg);
		cap_2. Subclass (IDC_CAP_2, hDlg);
		scr_2. Subclass (IDC_SCR_2, hDlg);

		cb_enable.  Subclass (IDC_ENABLE, hDlg);
		//--------------------------------------
		cb_enable.SetCheck (1);

		SetTimer (hDlg, 101,330, NULL);
		break;



	case WM_COMMAND:
		if (HIWORD(wParam) == BN_CLICKED)
		{
			int check;
			int nID = LOWORD(wParam);
			
			if (nID == IDC_NUM_1 || nID == IDC_NUM_2 || nID == IDC_NUM_3)
			{
				// You can use IsDlgButtonChecked, CheckDlgButton,....			*****
				// just as for an ordinary check box
				//
				switch (nID) 
				{
					case IDC_NUM_1:	check = IsDlgButtonChecked(hDlg,IDC_NUM_1);	break;
					case IDC_NUM_2:	check = IsDlgButtonChecked(hDlg,IDC_NUM_2);	break;
					case IDC_NUM_3:	check = IsDlgButtonChecked(hDlg,IDC_NUM_3);	break;
				}

				CheckDlgButton (hDlg, IDC_NUM_1, check);
				CheckDlgButton (hDlg, IDC_NUM_2, check);
				CheckDlgButton (hDlg, IDC_NUM_3, check);

				ToggleKey (VK_NUMLOCK);
			}

			if (nID == IDC_CAP_1 || nID == IDC_CAP_2 || nID == IDC_CAP_3)
			{
				// You can also use CCheckBox::SetGheck and CCheckBox::SetCheck	*****
				// to get/set the check state of subclassed check boxes
				//
				switch (nID) 
				{
					case IDC_CAP_1:	check = cap_1.GetCheck ();	break;
					case IDC_CAP_2:	check = cap_2.GetCheck ();	break;
					case IDC_CAP_3:	check = IsDlgButtonChecked(hDlg,IDC_CAP_3);	break;
				}

				cap_1.SetCheck (check);
				cap_2.SetCheck (check);
				CheckDlgButton (hDlg, IDC_CAP_3, check);

				ToggleKey (VK_CAPITAL);
			}

			if (nID == IDC_SCR_1 || nID == IDC_SCR_2 || nID == IDC_SCR_3)
			{
				switch (nID) 
				{
					case IDC_SCR_1:	check = scr_1.GetCheck ();	break;
					case IDC_SCR_2:	check = scr_2.GetCheck ();	break;
					case IDC_SCR_3:	check = IsDlgButtonChecked(hDlg,IDC_SCR_3);	break;
				}

				scr_1.SetCheck (check);
				scr_2.SetCheck (check);
				CheckDlgButton (hDlg, IDC_SCR_3, check);

				ToggleKey (VK_SCROLL);
			}


			if (nID == IDC_ENABLE)
			{
				check = cb_enable.GetCheck ();
				
				EnableWindow (GetDlgItem (hDlg,IDC_NUM_1),check);
				EnableWindow (GetDlgItem (hDlg,IDC_NUM_2),check);
				EnableWindow (GetDlgItem (hDlg,IDC_NUM_3),check);

				EnableWindow (GetDlgItem (hDlg,IDC_CAP_1),check);
				EnableWindow (GetDlgItem (hDlg,IDC_CAP_2),check);
				EnableWindow (GetDlgItem (hDlg,IDC_CAP_3),check);

				EnableWindow (GetDlgItem (hDlg,IDC_SCR_1),check);
				EnableWindow (GetDlgItem (hDlg,IDC_SCR_2),check);
				EnableWindow (GetDlgItem (hDlg,IDC_SCR_3),check);			
			}
		}
		break;  // WM_COMMAND


	case WM_TIMER:	// check num,caps, scroll lock
		{
			BYTE keyState[256];	
			GetKeyboardState((LPBYTE)&keyState);

			int check = ((keyState [VK_NUMLOCK] & 1) ? BST_CHECKED : BST_UNCHECKED);		
			CheckDlgButton (hDlg, IDC_NUM_1, check);
			CheckDlgButton (hDlg, IDC_NUM_2, check);
			CheckDlgButton (hDlg, IDC_NUM_3, check);			

			check = ((keyState [VK_CAPITAL] & 1) ? BST_CHECKED : BST_UNCHECKED);		
			CheckDlgButton (hDlg, IDC_CAP_1, check);
			CheckDlgButton (hDlg, IDC_CAP_2, check);
			CheckDlgButton (hDlg, IDC_CAP_3, check);			

			check = ((keyState [VK_SCROLL] & 1) ? BST_CHECKED : BST_UNCHECKED);		
			CheckDlgButton (hDlg, IDC_SCR_1, check);
			CheckDlgButton (hDlg, IDC_SCR_2, check);
			CheckDlgButton (hDlg, IDC_SCR_3, check);
		}
		break;

	case WM_CLOSE:		
		::EndDialog (hDlg, 0);
		return true;	
	}

	return false;
}


//------------------------------------
// ToggleKey
// toggle Num, Caps, Scroll lock
//------------------------------------
void ToggleKey (int key)
{	
	BYTE keyState[256];
	GetKeyboardState((LPBYTE)&keyState);

	if (bWinNT)
	{
		keybd_event( key,0x45, KEYEVENTF_EXTENDEDKEY | 0,0);			   // Simulate a key press
		keybd_event( key,0x45, KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP,0); // Simulate a key release
	}
	else
	{		
		keyState[key] = !(keyState [key] & 1);
		SetKeyboardState (keyState);
	}	
}
